gi-pango-1.0.29: Pango bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | Safe-Inferred
Language | Haskell2010

GI.Pango.Objects.FontMap

Contents

- Exported types
- Methods
  - changed
  - createContext
  - getFamily
  - getSerial
  - listFamilies
  - loadFont
  - loadFontset
  - reloadFont
- Properties
  - itemType
  - nItems

Description

A `PangoFontMap` represents the set of fonts available for a particular rendering system.

This is a virtual object with implementations being specific to particular rendering systems.

Synopsis

- newtype FontMap = FontMap (ManagedPtr FontMap)
- class (GObject o, IsDescendantOf FontMap o) => IsFontMap o
- toFontMap :: (MonadIO m, IsFontMap o) => o -> m FontMap
- fontMapChanged :: (HasCallStack, MonadIO m, IsFontMap a) => a -> m ()
- fontMapCreateContext :: (HasCallStack, MonadIO m, IsFontMap a) => a -> m Context
- fontMapGetFamily :: (HasCallStack, MonadIO m, IsFontMap a) => a -> Text -> m FontFamily
- fontMapGetSerial :: (HasCallStack, MonadIO m, IsFontMap a) => a -> m Word32
- fontMapListFamilies :: (HasCallStack, MonadIO m, IsFontMap a) => a -> m [FontFamily]
- fontMapLoadFont :: (HasCallStack, MonadIO m, IsFontMap a, IsContext b) => a -> b -> FontDescription -> m (Maybe Font)
- fontMapLoadFontset :: (HasCallStack, MonadIO m, IsFontMap a, IsContext b) => a -> b -> FontDescription -> Language -> m (Maybe Fontset)
- fontMapReloadFont :: (HasCallStack, MonadIO m, IsFontMap a, IsFont b, IsContext c) => a -> b -> Double -> Maybe c -> Maybe Text -> m Font
- getFontMapItemType :: (MonadIO m, IsFontMap o) => o -> m GType
- getFontMapNItems :: (MonadIO m, IsFontMap o) => o -> m Word32

# Exported types

newtype FontMap Source #

Memory-managed wrapper type.

Constructors

FontMap (ManagedPtr FontMap) |

#### Instances

Instances details

Eq FontMap Source # |
Instance details Defined in GI.Pango.Objects.FontMap Methods (==) :: FontMap -> FontMap -> Bool Source # (/=) :: FontMap -> FontMap -> Bool Source #
GObject FontMap Source # |
Instance details Defined in GI.Pango.Objects.FontMap
ManagedPtrNewtype FontMap Source # |
Instance details Defined in GI.Pango.Objects.FontMap Methods toManagedPtr :: FontMap -> ManagedPtr FontMap Source #
TypedObject FontMap Source # |
Instance details Defined in GI.Pango.Objects.FontMap Methods glibType :: IO GType Source #
HasParentTypes FontMap Source # |
Instance details Defined in GI.Pango.Objects.FontMap
IsGValue (Maybe FontMap) Source # | Convert `FontMap` to and from `GValue`. See `toGValue` and `fromGValue`.
Instance details Defined in GI.Pango.Objects.FontMap Methods gvalueGType_ :: IO GType Source # gvalueSet_ :: Ptr GValue -> Maybe FontMap -> IO () Source # gvalueGet_ :: Ptr GValue -> IO (Maybe FontMap) Source #
type ParentTypes FontMap Source # |
Instance details Defined in GI.Pango.Objects.FontMap type ParentTypes FontMap = '[Object, ListModel]

class (GObject o, IsDescendantOf FontMap o) => IsFontMap o Source #

Type class for types which can be safely cast to `FontMap`, for instance with `toFontMap`.

#### Instances

Instances details

(GObject o, IsDescendantOf FontMap o) => IsFontMap o Source # |
Instance details Defined in GI.Pango.Objects.FontMap

toFontMap :: (MonadIO m, IsFontMap o) => o -> m FontMap Source #

Cast to `FontMap`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

bindProperty, bindPropertyFull, changed, createContext, forceFloating, freezeNotify, getv, isFloating, itemsChanged, listFamilies, loadFont, loadFontset, notify, notifyByPspec, ref, refSink, reloadFont, runDispose, stealData, stealQdata, thawNotify, unref, watchClosure.

#### Getters

getData, getFamily, getItem, getItemType, getNItems, getProperty, getQdata, getSerial.

#### Setters

setData, setDataFull, setProperty.

## changed

fontMapChanged Source #

Arguments

:: (HasCallStack, MonadIO m, IsFontMap a) |
=> a | `fontmap`: a `PangoFontMap`
-> m () |

Forces a change in the context, which will cause any `PangoContext` using this fontmap to change.

This function is only useful when implementing a new backend for Pango, something applications won't do. Backends should call this function if they have attached extra data to the context and such data is changed.

Since: 1.34

## createContext

fontMapCreateContext Source #

Arguments

:: (HasCallStack, MonadIO m, IsFontMap a) |
=> a | `fontmap`: a `PangoFontMap`
-> m Context | Returns: the newly allocated `PangoContext`, which should be freed with `objectUnref`.

Creates a `PangoContext` connected to `fontmap`.

This is equivalent to `contextNew` followed by `contextSetFontMap`.

If you are using Pango as part of a higher-level system, that system may have it's own way of create a `PangoContext`. For instance, the GTK toolkit has, among others, `gtk_widget_get_pango_context()`. Use those instead.

Since: 1.22

## getFamily

fontMapGetFamily Source #

Arguments

:: (HasCallStack, MonadIO m, IsFontMap a) |
=> a | `fontmap`: a `PangoFontMap`
-> Text | `name`: a family name
-> m FontFamily | Returns: the `PangoFontFamily`

Gets a font family by name.

Since: 1.46

## getSerial

fontMapGetSerial Source #

Arguments

:: (HasCallStack, MonadIO m, IsFontMap a) |
=> a | `fontmap`: a `PangoFontMap`
-> m Word32 | Returns: The current serial number of `fontmap`.

Returns the current serial number of `fontmap`.

The serial number is initialized to an small number larger than zero when a new fontmap is created and is increased whenever the fontmap is changed. It may wrap, but will never have the value 0. Since it can wrap, never compare it with "less than", always use "not equals".

The fontmap can only be changed using backend-specific API, like changing fontmap resolution.

This can be used to automatically detect changes to a `PangoFontMap`, like in `PangoContext`.

Since: 1.32.4

## listFamilies

fontMapListFamilies Source #

Arguments

:: (HasCallStack, MonadIO m, IsFontMap a) |
=> a | `fontmap`: a `PangoFontMap`
-> m [FontFamily] |

List all families for a fontmap.

Note that the returned families are not in any particular order.

`PangoFontMap` also implemented the `ListModel` interface for enumerating families.

## loadFont

fontMapLoadFont Source #

Arguments

:: (HasCallStack, MonadIO m, IsFontMap a, IsContext b) |
=> a | `fontmap`: a `PangoFontMap`
-> b | `context`: the `PangoContext` the font will be used with
-> FontDescription | `desc`: a `PangoFontDescription` describing the font to load
-> m (Maybe Font) | Returns: the newly allocated `PangoFont` loaded, or `Nothing` if no font matched.

Load the font in the fontmap that is the closest match for `desc`.

## loadFontset

fontMapLoadFontset Source #

Arguments

:: (HasCallStack, MonadIO m, IsFontMap a, IsContext b) |
=> a | `fontmap`: a `PangoFontMap`
-> b | `context`: the `PangoContext` the font will be used with
-> FontDescription | `desc`: a `PangoFontDescription` describing the font to load
-> Language | `language`: a `PangoLanguage` the fonts will be used for
-> m (Maybe Fontset) | Returns: the newly allocated `PangoFontset` loaded, or `Nothing` if no font matched.

Load a set of fonts in the fontmap that can be used to render a font matching `desc`.

## reloadFont

fontMapReloadFont Source #

Arguments

:: (HasCallStack, MonadIO m, IsFontMap a, IsFont b, IsContext c) |
=> a | `fontmap`: a `PangoFontMap`
-> b | `font`: a font in `fontmap`
-> Double | `scale`: the scale factor to apply
-> Maybe c | `context`: a `PangoContext`
-> Maybe Text | `variations`: font variations to use
-> m Font | Returns: the modified font

Returns a new font that is like `font`, except that its size is multiplied by `scale`, its backend-dependent configuration (e.g. cairo font options) is replaced by the one in `context`, and its variations are replaced by `variations`.

Since: 1.52

# Properties

## itemType

The type of items contained in this list.

getFontMapItemType :: (MonadIO m, IsFontMap o) => o -> m GType Source #

Get the value of the “`item-type`” property. When overloading is enabled, this is equivalent to

    get fontMap #itemType

## nItems

The number of items contained in this list.

getFontMapNItems :: (MonadIO m, IsFontMap o) => o -> m Word32 Source #

Get the value of the “`n-items`” property. When overloading is enabled, this is equivalent to

    get fontMap #nItems